package com.tuya.pulsar.websocket.demo;

import com.alibaba.fastjson.JSON;
import com.tuya.pulsar.websocket.demo.mq.AESBase64Utils;
import com.tuya.pulsar.websocket.demo.mq.IMessageHandler;
import com.tuya.pulsar.websocket.demo.mq.MessageVO;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import sun.misc.BASE64Decoder;

public class MessageHandler implements IMessageHandler {
    private static Logger logger = LoggerFactory.getLogger(MessageHandler.class);
    final static BASE64Decoder decoder = new BASE64Decoder();

    @Override
    public void handler(String payload) {
        try {
            String jsonMessage = new String(new String(decoder.decodeBuffer(payload), "UTF-8"));
            logger.info("receive msg, jsonMessage={}", new String(decoder.decodeBuffer(payload), "UTF-8"));
            MessageVO vo = JSON.parseObject(jsonMessage, MessageVO.class);
            logger.info("the real message data:" + AESBase64Utils.decrypt(vo.getData(), MqConfigs.accessKey.substring(8, 24)));
            //TODO process the messages you receive，business logic is implemented in this method
        } catch (Exception e) {
            logger.error("error ,", e);
        }
    }
}
